package com.mf.interfaceTest;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnCancelListener;
import android.util.Log;
import android.widget.Toast;

import com.mf.mpos.lefu.Api;
import com.mf.mpos.lefu.DeviceInfo;
import com.mf.mpos.message.MessageComm;
import com.mf.mpos.pub.Controler;
import com.mf.mpos.pub.CommEnum.TRANSTYPE;
import com.mf.mpos.yj.Device;
import com.mf.mpos.yj.MposListener;
import com.mf.mpos.yj.MposMain;
import com.mf.page.menu.MainMenuData;

public class YJDemo {

	static Context c;
	
	static MposMain mfapi = null;
	public static void initapi( Context cxt){
		 c = cxt;
		initmenu( MainMenuData.Instance() );
	}
	public static boolean initmenu(MainMenuData data)
	{
		data.addItem("应用主菜单" ,	"银嘉" , "");
		data.addItem("银嘉",	"开始测试", "银嘉.开始测试");	
		return true;		
	}
	static void showmsg(String msg){
		Toast.makeText(c, msg,Toast.LENGTH_SHORT ).show();
		Log.i("YJDemo", msg);
	}
			
	static MposListener listener = new MposListener(){

		@Override
		public void onBloothNotOpen() {
			// TODO Auto-generated method stub
			showmsg("onBloothNotOpen");
		}

		@Override
		public void onDeviceConnected() {
			// TODO Auto-generated method stub
			Device dev = mfapi.getDeviceInfo();
			showmsg("onDeviceConnected" +" "+ dev.psamNo +" "+ dev.uid );
			

			mfapi.finishInitDevice("20112511", "234234", "商户名");
			//mfapi.reSetMasterkey("BCDE2ESCBCDE2ESCBCDE2ESCBCDE2ESC");

			mfapi.startPOS("12011", "124545", 100, TRANSTYPE.FUNC_SALE,60);
			
		}

		@Override
		public void onDeviceDisConnected() {
			// TODO Auto-generated method stub

			showmsg("onDeviceDisConnected");
		}

		@Override
		public void onDeviceScanTimeout() {
			// TODO Auto-generated method stub
			showmsg("onDeviceScanTimeout");
		}

		@Override
		public void onDeviceConnectTimeout() {
			// TODO Auto-generated method stub

			showmsg("onDeviceConnectTimeout");
		}

		@Override
		public void onFindDevice(BluetoothDevice device) {
			// TODO Auto-generated method stub
			showmsg("onFindDevice " + device.getName());
			//if( device.getAddress().equals("88:1B:99:03:8F:DC") )
			if( device.getName().equals("MF60-10001348") )				 
			{
				mfapi.conectionDevice(device, true);
			}
		}

		@Override
		public void onFinishFindDevice() {
			// TODO Auto-generated method stub
			showmsg("onFinishFindDevice ");
		}

		@Override
		public void onYJEMVError(int errorCode, String errorMessage) {
			// TODO Auto-generated method stub
			showmsg("onYJEMVError " + errorCode + " " + errorMessage);
		}

	

		@Override
		public void onFlotCardCancer() {
			// TODO Auto-generated method stub
			showmsg("onFlotCardCancer ");
		}

		@Override
		public void onTransStatusChange(int status) {
			// TODO Auto-generated method stub

			showmsg("onTransStatusChange " + status);
			if( status == 4 ){
				
			}
		}

		@Override
		public void onBackCardNo(String cardNo) {
			// TODO Auto-generated method stub
			showmsg("onBackCardNo " + cardNo);
		}

		@Override
		public void onGetTrackData(String txtPan, String data) {
			// TODO Auto-generated method stub
			showmsg("onGetTrackData " + txtPan + " " + data);
		}
		
	};
	
	
	

	
	
	public static boolean testid(Activity ac, final String id)
	{
		boolean handle = false;
		
		if( id.equals("银嘉.开始测试") ){
			if( mfapi == null )
			{
				mfapi = MposMain.getMposMain(c, listener);
			}
			
			
			final ProgressDialog pdialog = new ProgressDialog( ac );	
			pdialog.setTitle("开始测试");
			pdialog.setMessage("正在测试...");
			pdialog.setCancelable(true);
			pdialog.setCanceledOnTouchOutside(false);
			pdialog.setOnCancelListener( new OnCancelListener(){
				@Override
				public void onCancel(DialogInterface dialog) {
					// TODO Auto-generated method stub
					mfapi.cancelWaitForCard();
					pdialog.dismiss();
				}
			});
			//pdialog.show();
			mfapi.startScanDevice();
			handle =  true;
		}
		return handle;		
	}
	
}
