package com.mf.page;

import android.annotation.TargetApi;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothManager;
import android.bluetooth.le.BluetoothLeScanner;
import android.bluetooth.le.ScanCallback;
import android.bluetooth.le.ScanResult;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Build;
import android.os.Bundle;
import android.app.Activity;
import android.os.Handler;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.Toast;

import com.mf.R;
import com.mf.mpos.message.MessageComm;
import com.mf.mpos.pub.Controler;
import com.mf.mpos.pub.ControlerAsync;
import com.mf.mpos.pub.result.ConnectPosResult;
import com.mf.mpos.yj.Device;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.StringTokenizer;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class BLEDevicesActivity extends Activity {

    private Button btnscan;
    private Button btnconnect;
    private Handler mHandler;
    private ListView listview;
    private ExecutorService executor;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_bledevices);

        executor = Executors.newSingleThreadExecutor();
        mHandler = new Handler(getMainLooper());

        listview = (ListView) findViewById( R.id.listView);
        listview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Object item = listview.getAdapter().getItem(position);
                String[] items =  item.toString().split(" ");
                final String mac = items[0];

                final ProgressDialog pdlg = new ProgressDialog(BLEDevicesActivity.this);
                pdlg.setTitle("提示");
                pdlg.setMessage("正在连接..");
                pdlg.setCancelable(true);
                pdlg.setCanceledOnTouchOutside(false);
                pdlg.setOnCancelListener( new DialogInterface.OnCancelListener(){
                    @Override
                    public void onCancel(DialogInterface dialog) {
                        // TODO Auto-generated method stub
                        Controler.CancelComm();
                    }
                });
                pdlg.show();

                executor.submit(new Callable<Boolean>() {
                    @Override
                    public Boolean call() throws Exception {
                        ConnectPosResult ret = Controler.connectPos(mac);
                        final boolean bret = Controler.posConnected();

                        mHandler.postDelayed(new Runnable() {
                            @Override
                            public void run() {
                                pdlg.dismiss();;

                                if ( bret ){
                                    BLEDevicesActivity.this.finish();
                                }
                                else
                                {
                                    Toast.makeText(MessageComm.s_appcontext, "连接失败,请重试",Toast.LENGTH_SHORT ).show();
                                }
                            }
                        },100);
                        return bret;
                    }
                });

            }
        });


        btnscan = (Button) findViewById( R.id.buttonscan);
        btnscan.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                BluetoothManager blueManager = (BluetoothManager) getSystemService(Context.BLUETOOTH_SERVICE);
                blueManager.getAdapter().enable();
                final BluetoothLeScanner scanner = blueManager.getAdapter().getBluetoothLeScanner();
                mHandler.postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        btnscan.setEnabled(true);
                        scanner.stopScan(mLeScanCallback);

                    }
                } , 5000);

                devs.clear();
                scanner.startScan( mLeScanCallback  );
                btnscan.setEnabled(false);
            }
        });
    }

    List<String> devs = new ArrayList<String>();
    void refrushlistview()
    {
        ArrayAdapter<String > adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, devs);
        listview.setAdapter( adapter );
    }

    public ScanCallback mLeScanCallback = new ScanCallback() {
        @Override
        public void onScanResult(int callbackType, ScanResult result) {
            BluetoothDevice device = result.getDevice();
            int index = 0;
            for (; index < devs.size(); index++) {
                if (devs.get(index).indexOf(device.getAddress()) >= 0) {
                    break;
                }
            }

            String item = device.getAddress() + " " + device.getName();
            if (index < devs.size()) {
                devs.set(index, item);
            } else {
                devs.add(item);
            }

            mHandler.post(new Runnable() {
                @Override
                public void run() {
                    refrushlistview();
                }
            });

        }
    };

}
