package com.pay.boss.util;
public class Utils {
	/**
	 * 进行磁道解密
	 * @param randomkey  app端传递的随机数
	 * @param mainkey    sn对应的mainkey
	 * @param track      卡磁道密文
	 * @return
	 */
	public static String DECODETRACK(String randomKey,String mainKey,String track){
		/**
		 * 客户端-》 SN号, randomKey, 加密后的磁道信息
		 * SN号-》从服务器拿mainKey
		 */
		if(mainKey==null)
			mainKey="020000000000000000000000000000020200000000000000";
		//根据随机数进行异或运算
		String xor = xorHex(randomKey, "FFFFFFFFFFFFFFFF");//
		//把随机数 + 异或运算的结果 拼接
		String tmp = randomKey + xor;
		//用设备主秘钥 加密 拼接的结果
		TripleDes tdes = TripleDes.getInstance();
		byte[] r = tdes.encryptEBC(hex2byte(mainKey.getBytes()), 
				hex2byte(tmp.getBytes()), TripleDes.MODE_CBC);
		//生成工作秘钥
		String workKey = byte2hex(r);
		//用工作秘钥去解密 磁道信息
		int lenWorkey=workKey.length();
		if(lenWorkey<48)
			workKey+=workKey.substring(0,48-lenWorkey);
		r = tdes.decryptEBC(
				hex2byte(workKey.getBytes()), hex2byte(track.getBytes()), TripleDes.MODE_CBC);
		String data = byte2hex(r);
		
		String trackData=data.replaceAll("F", "");// data.replace(new char('F'), new char(''));
		System.out.println("去掉F后的真实磁道2信息 = " +trackData);		
		return trackData;
			
	}
	
	public static void main(String[] args) {
		
		System.out.println(DECODETRACK("171c1e84dd1015fb","020000000000000000000000000000020200000000000000","c08cf41a2d31f655fc65fa400ba3b0c906aa4fa917959a57"));
		
		/**
		 * 客户端-》 SN号, randomKey, 加密后的磁道信息
		 * SN号-》从服务器拿mainKey
		 */
		
//		//客户端传给你的随机数
//		String randomKey = "171c1e84dd1015fb";
//		//根据随机数进行异或运算
//		String xor = xorHex(randomKey, "FFFFFFFFFFFFFFFF");//
//		
//		/*if (!xor.equalsIgnoreCase("E8E3E17B22EFEA04")) { //E8E3E17B22EFEA04 
//			//验证结果失败
//			System.out.println("验证结果失败");
//			return;
//		}*/
//		
//		//把随机数 + 异或运算的结果 拼接
//		String tmp = randomKey + xor;
//		//通过SN号从后台去拿的MK
//		//字节 A(8个字节) + B(8个字节) + A(8个字节)
//		String mainKey = "020000000000000000000000000000020200000000000000";//从数据库查询明文
//		//用设备主秘钥 加密 拼接的结果
//		TripleDes tdes = TripleDes.getInstance();
//		byte[] r = tdes.encryptEBC(hex2byte(mainKey.getBytes()), 
//				hex2byte(tmp.getBytes()), TripleDes.MODE_EBC);
//		//生成工作秘钥
//		String workKey = byte2hex(r);
//		System.out.println("生成的工作秘钥 = " + workKey);
//		if (!workKey.equalsIgnoreCase("219FA3F25B881A9E7470BF1C7FF245E3")) {
//			//生成工作秘钥失败
//			return;
//		}
//		//用工作秘钥去解密 磁道信息
//		//字节 A(8个字节) + B(8个字节) + A(8个字节)
//		String track2 = "c08cf41a2d31f655fc65fa400ba3b0c906aa4fa917959a57";
//		r = tdes.decryptEBC(
//				hex2byte("219FA3F25B881A9E7470BF1C7FF245E3219FA3F25B881A9E".getBytes()), hex2byte(track2.getBytes()), TripleDes.MODE_EBC);
//		String data = byte2hex(r);
//		System.out.println("去掉F后的真实磁道2信息 = " + data.replace("F", ""));
		
		
		/*String mainKey1 = "8CA64DE9C1B123A700000000";//从数据库查询明文
		//用设备主秘钥 加密 拼接的结果
		//TripleDes tdes = TripleDes.getInstance();
		byte[] r1 = tdes.encryptEBC(hex2byte((mainKey1).getBytes()), 
				hex2byte((tmp).getBytes()), TripleDes.MODE_EBC);
		//生成工作秘钥
		String workKey1 = byte2hex(r1);
		System.out.println("生成的工作秘钥 = " + workKey1);*/
		
    }
	
	public static String xorHex(String a, String b) {
		char[] chars = new char[a.length()];
		for (int i = 0; i < chars.length; i++) {
			chars[i] = toHex(fromHex(a.charAt(i)) ^ fromHex(b.charAt(i)));
		}
		return new String(chars);
	}
	
	private static int fromHex(char c) {
		if (c >= '0' && c <= '9') {
			return c - '0';
		}
		if (c >= 'A' && c <= 'F') {
			return c - 'A' + 10;
		}
		if (c >= 'a' && c <= 'f') {
			return c - 'a' + 10;
		}
		throw new IllegalArgumentException();
	}

	private static char toHex(int nybble) {
		if (nybble < 0 || nybble > 15) {
			throw new IllegalArgumentException();
		}
		return "0123456789ABCDEF".charAt(nybble);
	}
	
	// 转换成十六进制字符串
	public static String byte2hex(byte[] b) {
		String hs = "";
		String stmp = "";
		for (int n = 0; n < b.length; n++) {
			stmp = (java.lang.Integer.toHexString(b[n] & 0XFF));
			if (stmp.length() == 1) {
				hs = hs + "0" + stmp;
			} else {
				hs = hs + stmp;
			}
			if (n < b.length - 1) {
				hs = hs + "";
			}
		}
		return hs.toUpperCase();
	}

	/**
	 * 字符串转java字节码
	 * 
	 * @param b
	 * @return
	 */
	public static byte[] hex2byte(byte[] b) {
		if ((b.length % 2) != 0) {
			throw new IllegalArgumentException("长度不是偶数");
		}
		byte[] b2 = new byte[b.length / 2];
		for (int n = 0; n < b.length; n += 2) {
			String item = new String(b, n, 2);
			// 两位一组，表示一个字节,把这样表示的16进制字符串，还原成一个进制字节

			b2[n / 2] = (byte) Integer.parseInt(item, 16);
		}
		b = null;
		return b2;
	}
}
