package com.td.three.mmb.pay.net; 

import java.security.SecureRandom;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;

import com.td.three.mmb.pay.net.Str2Hex;

/**
 * @ProjectName:  [XYF_PAY] 
 * @Package:      [com.td.three.mmb.pay.utils.CardPasswordEncryption.java]  
 * @ClassName:    [CardPasswordEncryption]   
 * @Description:  [音频密码加密]   
 * @Author:       [wz.bao]   
 * @CreateDate:   [2015年6月1日 下午3:27:49]   
 * @UpdateUser:   [huge]   
 * @UpdateDate:   [2015年6月1日 下午3:27:49]   
 * @UpdateRemark: [无]  
 * @Version:      [v1.0] 
 *
 */
public class CardPasswordEncryption {
	
	private final static String DES = "DES";
	
	private static final char[] base64EncodeChars = new char[] { 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/' }; 

	
	/**
	 * 加密密码
	 * @param password 密码
	 * @param workKey 工作密钥
	 * @return
	 */
	public final static String encryptionPassword(String password,String workKey){
		
		String str = new String(encrypt(password,workKey));
		
		return encode(str.getBytes());
	}

   public final static String encrypt(String data, String key){
    	if(data!=null)
        try {
            return byte2hex(encrypt(data.getBytes(),key.getBytes()));
        }catch(Exception e) {
			throw new RuntimeException(e);
        }
        return null;
    }
   
   private static String byte2hex(byte[] b) {
		StringBuilder hs = new StringBuilder();
		String stmp;
		for (int n = 0; b!=null && n < b.length; n++) {
			stmp = Integer.toHexString(b[n] & 0XFF);
			if (stmp.length() == 1)
				hs.append('0');
			hs.append(stmp);
		}
		return hs.toString().toUpperCase();
	}
   
	public static byte[] encrypt(byte[] src, byte[] key) throws RuntimeException {
		try{
			
			SecureRandom sr = new SecureRandom();
			DESKeySpec dks = new DESKeySpec(key);
			SecretKeyFactory keyFactory = SecretKeyFactory.getInstance(DES);
			SecretKey securekey = keyFactory.generateSecret(dks);
			Cipher cipher = Cipher.getInstance(DES);
			cipher.init(Cipher.ENCRYPT_MODE, securekey, sr);
			return cipher.doFinal(src);
			
		}catch(Exception e){
			throw new RuntimeException(e);
		}
	}
	
	
	public static String encode(byte[] data) { 
		   byte[] dataByte=Str2Hex.GetEncodeStr(new String(data)).getBytes();
	       StringBuffer sb = new StringBuffer(); 
	       int len = dataByte.length; 
	       int i = 0; 
	       int b1, b2, b3; 

	       while (i < len) { 
	           b1 = dataByte[i++] & 0xff; 
	           if (i == len) { 
	               sb.append(base64EncodeChars[b1 >>> 2]); 
	               sb.append(base64EncodeChars[(b1 & 0x3) << 4]); 
	               sb.append("=="); 
	               break; 
	           } 
	           b2 = dataByte[i++] & 0xff; 
	           if (i == len) { 
	               sb.append(base64EncodeChars[b1 >>> 2]); 
	               sb.append(base64EncodeChars[((b1 & 0x03) << 4) | ((b2 & 0xf0) >>> 4)]); 
	               sb.append(base64EncodeChars[(b2 & 0x0f) << 2]); 
	               sb.append("="); 
	               break; 
	           } 
	           b3 = dataByte[i++] & 0xff; 
	           sb.append(base64EncodeChars[b1 >>> 2]); 
	           sb.append(base64EncodeChars[((b1 & 0x03) << 4) | ((b2 & 0xf0) >>> 4)]); 
	           sb.append(base64EncodeChars[((b2 & 0x0f) << 2) | ((b3 & 0xc0) >>> 6)]); 
	           sb.append(base64EncodeChars[b3 & 0x3f]); 
	       } 
	       return sb.toString(); 
	   } 
	
}
